
using System;
using System.Collections.Generic;
using System.Text;
using ScrewTurn.Wiki.PluginFramework;

namespace ScrewTurn.Wiki {

	/// <summary>
	/// Represents a Local Page.
	/// </summary>
	[Serializable]
	public class LocalPageInfo : PageInfo {

		private string file;

		/// <summary>
		/// Initializes a new instance of the <b>PageInfo</b> class.
		/// </summary>
		/// <param name="name">The Name of the Page.</param>
		/// <param name="provider">The Pages Storage Provider that manages this Page.</param>
		/// <param name="status">The Status of the Page.</param>
		/// <param name="creationDateTime">The creation Date/Time.</param>
		/// <param name="file">The file where the Page is stored.</param>
		public LocalPageInfo(string name, IPagesStorageProvider provider, PageStatus status, DateTime creationDateTime, string file)
			: base(name, provider, status, creationDateTime) {
			this.file = file;
		}

		/// <summary>
		/// Gets or sets the File.
		/// </summary>
		public string File {
			get { return file; }
			set { file = value; }
		}

	}

}
