
using System;
using System.Collections.Generic;
using System.Text;

namespace ScrewTurn.Wiki.PluginFramework {

	/// <summary>
	/// Contains information about a Provider.
	/// </summary>
	[Serializable]
	public class ComponentInformation {

		/// <summary>
		/// The Name of the Component.
		/// </summary>
		protected string name;
		/// <summary>
		/// The Author of the Component.
		/// </summary>
		protected string author;
		/// <summary>
		/// The URL of the Component.
		/// </summary>
		protected string url;

		/// <summary>
		/// Initializes a new instance of the <b>ComponentInformation</b> class.
		/// </summary>
		/// <param name="name">The Name of the Component.</param>
		/// <param name="author">The Author of the Component.</param>
		/// <param name="url">The URL of the Component.</param>
		public ComponentInformation(string name, string author, string url) {
			this.name = name;
			this.author = author;
			this.url = url;
		}

		/// <summary>
		/// Gets the Name of the Component.
		/// </summary>
		public string Name {
			get { return name; }
		}

		/// <summary>
		/// Gets the Author of the Component.
		/// </summary>
		public string Author {
			get { return author; }
		}

		/// <summary>
		/// Gets the URL of the Component.
		/// </summary>
		public string Url {
			get { return url; }
		}

	}

}
